/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_syssvc.h 845 2008-05-24 18:49:57Z roi $
 */

/*
 *  ƥॵӥΥåװ¸ʽŻ AKI-H8/3048Fѡ
 *
 *  ƥॵӥΥåװ¸Υ󥯥롼ɥե롥Υե
 *  Ƥϡݡͥȵҥե˵Ҥ졤Υե̵ʤ
 *  ߡ
 */
#ifndef TOPPERS_TARGET_SYSSVC_H
#define TOPPERS_TARGET_SYSSVC_H

#include "h8300h_gcc/core_syssvc.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME     "AKI-H8/3048F"

/*
 *  ưåɽ
 */
#define TARGET_COPYRIGHT \
"Copyright (C) 2001-2008 by Industrial Technology Institute,\n" \
"                            Miyagi Prefectural Government, JAPAN\n" \
"Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering\n" \
"                 Tomakomai National College of Technology, JAPAN\n" \
"Copyright (C) 2008 by GELJET Designing Center RICOH COMPANY,LTD.\n"

/*
 *  ƥ٥ϤΤʸ
 *
 *  åȰ¸ˡǡʸcɽ//¸롥
 */
extern void	target_fput_log(char_t c);

/*
 *  ꥢݡȿ
 *  ݡȤ륷ꥢǥХοϺ 2
 *  TNUM_SIOPPDIC٥ʥǥХñ̡
 *  TNUM_PORTGDIC٥ʥƥΡ
 */
#define TNUM_SIOP_H8_SCI	1
#define TNUM_PORT      		TNUM_SIOP_H8_SCI

/*
 *  Ѥ륷ꥢݡID
 */
#define	SYSTEM_PORTID	1
#define	USER_PORTID		2


/*
 *  ꥢݡȤΥܡ졼Ȥ˴ؤ
 */
#define SYSTEM_BAUD_RATE	38400			/* bps	*/
#define USER_BAUD_RATE		38400			/* bps	*/

/*
 *  ƥϢ
 *
 *  ǥե̤ͤꡥ
 */
#define LOGTASK_PORTID  SYSTEM_PORTID

/*
 *  Υå
 */
#define LOGTASK_STACK_SIZE	384	/* åΰΥ */

/*
 *  ꥢХåե
 */
#define SERIAL_RCV_BUFSZ1   128
#define SERIAL_SND_BUFSZ1   128

#endif /* TOPPERS_TARGET_SYSSVC_H */
